//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TForm1::GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
//---------------------------------------------------------------------------
BOOL TForm1::LoadpcltoimageDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"pcltoimage.dll");	

	m_hinstLib = LoadLibrary(path);
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMBegin = (MBegin *)GetProcAddress(m_hinstLib, "MBegin");
	if( pMBegin == NULL ){ 
		FreepcltoimageDll(); 
		return FALSE;
	}
	pMConvert = (MConvert *)GetProcAddress(m_hinstLib, "MConvert");
	if( pMConvert == NULL ){ 
		FreepcltoimageDll(); 
		return FALSE;
	}
	pMSetParam = (MSetParam *)GetProcAddress(m_hinstLib, "MSetParam");
	if( pMSetParam == NULL ){ 
		FreepcltoimageDll(); 
		return FALSE;
	}
	pMEnd = (MEnd *)GetProcAddress(m_hinstLib, "MEnd");
	if( pMEnd == NULL ){ 
		FreepcltoimageDll(); 
		return FALSE;
	}
	return TRUE;
}
//---------------------------------------------------------------------------
BOOL TForm1::FreepcltoimageDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}                 
	return TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if( LoadpcltoimageDll() == FALSE ){
		ShowMessage("Load pcltoimage.dll failed!");
		return;
	}

	char infile[256],outpath[256];
	GetModulePath(infile,"test.pcl");
	GetModulePath(outpath,"outpath\\");

	long id = pMBegin();
	if(id>0){
		long imagetype = IMAGE_FORMAT_TIF;
		long bitcount = BITCOUNT_24;
		long quality = 75;
		long rotate = 0;
		long width = 0;
		long height = 0;
		long xdpi = 150;
		long ydpi = 150;

		long compression = COMPRESSION_LZW;
		long multipage = 1;

		//Set Output image param
		pMSetParam( id,imagetype,bitcount,quality,rotate,width,height,xdpi,ydpi,compression,multipage);

		//Convert to tiff file (multiple page)
		pMConvert(id,infile,outpath,"multiple");
		pMEnd(id);
	}		

	FreepcltoimageDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	if( LoadpcltoimageDll() == FALSE ){
		ShowMessage("Load pcltoimage.dll failed!");
		return;
	}

	char infile[256],outpath[256];
	GetModulePath(infile,"test.pcl");
	GetModulePath(outpath,"outpath\\");

	long id = pMBegin();
	if(id>0){
		long imagetype = IMAGE_FORMAT_JPG;
		long bitcount = BITCOUNT_8G;//256 color grayscale( 8 bits )
		long quality = 85;
		long rotate = 90;
		long width = 1000;
		long height = 800;
		long xdpi = 200;
		long ydpi = 200;
		//only for tiff
		long compression = 0;
		long multipage = 0;

		//Set Output image param
		pMSetParam( id,imagetype,bitcount,quality,rotate,width,height,xdpi,ydpi,compression,multipage);

		//Convert to jpg file
		pMConvert(id,infile,outpath,"jpg");
		pMEnd(id);
	}

	FreepcltoimageDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
